CON
{''Hardware version 3.11 - see diagram.
''
} 
 _clkmode       = xtal1 + pll16x                        ' use crystal x 16
 _xinfreq       = 5_000_000                             'with 5mhz crystal 
      
  DEV_SD_CLK        = 18
  DEV_SD_DI         = 19
  DEV_SD_DO         = 20                                 
  DEV_SPI_EN        = 21                               ''SPI Enable enumeration
  DEV_SPI_ADD0      = 22                               ''Device address 0 enumeration
  DEV_SPI_ADD1      = 23                               ''Device address 1 enumeration
  DEV_SPI_ADD_LE    = 24
  
  DEV_SPI_LCD_RES    = 0                 ''Device id for LCD reset
  SDC     = 1
  TSC     = 2
  EXT     = 3  
 DEV_SPI_EXT_POT_CS  = 0
 DEV_SPI_EXT_SW_CS   = 1
                      
  BGCOLOR                       = $ffff
  TXTCOLOR                      = $0000
   Pressed                       = 1  
   NotPressed                    = 0
faderUpBtnBound                 = 499     ''y < 499
faderDnBtnBound                 = 3700    ''y > 3699                  3200, 1600, 320
fadertouchoffset                = 320         ''3375 < y < 825  range e


  offset = 8 * 2048 ' the block offset of where we do writes 

VAR
 long Screen_Buffer, CRbuffer
 
   byte tbuf[20]
   byte bigbuf[8192]
   
   long BackgroundColor, ActiveTextColor, stringptr[65], maxdur,sr ,speedresults
   BYTE Fader0[3], Fader1[3], Fader2[3], Fader3[3], FaderPOS, NewFaderValue, OldValue              'FaderOrentation holds 0 for landscape, portrait not enabled 
  word Button0[5], Button1[5], Button2[5], Button3[5], Button4[5], Button5[5],  ButtonX, ButtonY, ButtonState, OldState
      WORD NotPressedBGC,NotPressedATC,PressedBGC,PressedATC, ButtonName, ButtonReg                       'ButtonGroup,oldButtonGroup,faderOrentation,
OBJ pfw :"PropFont_asmDone"
     wait : "timing"  
     'pst : "parallax serial terminal"
     spi : "spi_asm"
     sdfat: "fsrw"
      block: "safe_spi"     
PUB BOOT   | f                       'bootstrap, initalizes pins, then starts pst, init display, start asm, clear screen and display hello world
  WAIT.PAUSE1S(5)
  initPins
BackgroundColor := $ffe0
ActiveTextColor := %0000  
 long[@Screen_Buffer]          := $ffff                        'make sure screen buffer does not equal 0  
  pfw.Start(@Long[@Screen_Buffer])                          'Start Asm Driver, needs to be changed to pass screen buffer from top object
  pfw.size(1)
  spi.start(3,0)
    
   pfw.ClearScreen(BackgroundColor)            'Draw White Screen with asm
  
   repeat
       LCD_Menu

pub go | x
   
   maxdur := 2 ' the max duration in seconds; keep below 10sec to avoid clock wrap
   maxdur *= clkfreq
   x := \start
   pfw.str(string(13,"!!!!!Erroneously returned from start!!!!!", 13))
   pfw.dec(x)
   pfw.newline

   
pub start_block_layer : retval | i

  OUTA[DEV_SPI_EN] := 1    
  outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
  dira[DEV_SPI_EN..DEV_SD_CLK] := 0
  dira[DEV_SPI_ADD1..DEV_SPI_ADD0] := 1  

  'retval := \ sdfat.mount_explicit(20,18,19,21) 
  
  retval := \block.start_explicit(20,18,19,21) 
              
        
  if retval < 0
    pfw.str( string( 13, "Mount failed spectacularly!", 13, "Command => Response", 13 ) )
    {
    i := block.get_log_pointer
    repeat while byte[i] <> 0
      term.dec( byte[i++] & 63 )
      term.str( string( " => "  ) )
      term.dec( byte[i++] )
      term.tx( 13 )
    }
    abort( retval )
pub stop_block_layer
   block.stop
pub start
  pfw.size(2)
  pfw.clearscreen(0)
  pfw.setColors($0000,$FFFF)  
   'term.start(115200)
   'repeat
      sr := 0
      pfw.str(string(13, "Waiting for key press to start tests ", 13))
      pfw.newline
      tswait
      ' if these fail, comment out the next line
      mounttests
      rawspeed
      fsrwspeed
      block.stop
      pfw.str(string(13, "Repeating all the speed results:", 13))
     tswait
      pfw.newline
      showallspeed
      pfw.str(string(13, " All done!" , 13))
      pfw.newline
      tswait
pub error(s)
   pfw.dec(s)
   abort(-1234)
pub mounttests | r, startcnt, bytes, n, duration, i
   pfw.str(string(13,"Mount tests first ",13))
   
   pfw.str(string(13,"First mount.",13))
  
   start_block_layer
   pfw.str(string(13,"Succeeded; stopping cog.", 13))
 
   stop_block_layer
   pfw.str(string(13, "Second mount.", 13))
  
   start_block_layer
   pfw.str(string(13, "Succeeded.", 13))
 
   pfw.str(string(13,"Reading block 0(should be a boot block)",13))
 
   bytefill(@bigbuf, 0, 512)
   block.readblock(0, @bigbuf)
   pfw.str(string(13,"Read finished;checking for boot block signature",13))
  
   if !(bigbuf[510] == $55 and bigbuf[511] == $aa)
      error(string(13,"boot block signature not found",13))
      
   pfw.str(string(13,"Boot block checks out; unmounting", 13))
 
   stop_block_layer
   pfw.str(string(13, "Third mount." , 13))
   
   start_block_layer
   pfw.str(string(13, "Succeeded.", 13))
  
    pfw.str(string(13,"Reading block0again(should still be a boot block)",13))
   
   
   bytefill(@bigbuf, 0, 512)
   block.readblock(0, @bigbuf)
   pfw.str(string(13,"Read finished; checking for boot block signature",13))
  
   if !(bigbuf[510] == $55 and bigbuf[511] == $aa)
      error(string(13, "boot block signature not found",13))
   
   pfw.str(string(13," Boot block checks out; writing it back", 13 ))

   block.writeblock(0, @bigbuf)
   pfw.str(string(13," Write finished; unmounting ", 13))
   
   stop_block_layer
   pfw.str(string(13,"Fourth mount", 13))
   
   start_block_layer
   pfw.str(string(13, "Succeeded.", 13))

   pfw.str(string(13,"Reading block 0 again(should still be a boot block)",13))
   
   bytefill(@bigbuf, 0, 512)
   block.readblock(0, @bigbuf)
   pfw.str(string(13,"Read finished;checking for bootblocksignature",13))
  
   if !(bigbuf[510] == $55 and bigbuf[511] == $aa)
      error(string(13, "boot block signature not found ",13))
  
   stop_block_layer
   pfw.str(string(13, "Block layer seems to check out ",13))
  
   return
pub showspeed(b) | duration, bytes
   duration := long[b][1]
   bytes := long[b][2]
   pfw.str(long[b][0])
   
   pfw.dec( (bytes + 512) / 1024 )
   pfw.str(string(" kB in "))
   pfw.dec(duration/(clkfreq/1000))
   pfw.str(string(" ms at "))
   pfw.dec(bytes/(duration/(clkfreq/1024)))
   pfw.str(string(" kB/s",13))
pub addspeed(s, dur, n)
   speedresults[sr++] := s
   speedresults[sr++] := dur
   speedresults[sr++] := n
   showspeed(@speedresults[sr-3])
pub showallspeed | s
   pfw.clearscreen($0601)
   tswait
   pfw.str(string(13,"Clock:",13))
   pfw.dec(clkfreq)
   pfw.str(string(13," ClusterSize:",13))
   pfw.dec(sdfat.getclustersize)
   pfw.str(string(13," ClusterCount: ",13))
   pfw.dec(sdfat.getclustercount)

   repeat s from 0 to sr-3 step 3
      showspeed(@speedresults[s])
pub rawspeed | r, startcnt, bytes, n, duration, ptr
   start_block_layer
   pfw.clearscreen($8888)
   pfw.str(string(13, "Now speed tests", 13))

   ' NOTE: SOME CARDS CAN NOT HANDLE A WRITE BEFORE A READ!!
   ' (not an issue for fsrw, we always read block 0 first thing)
   block.readblock(0, @bigbuf)
'
'   For writes, we will destroy whatever data is wherever we write, if there is data
'   there.  So we write high up on the card.  But at the same time, we don't want to
'   mess up the metadata.
'   
   pfw.str(string(13,"How fast can we write, sequentially", 13))
   pfw.newline
   n := 128
   duration := 0
   ptr := offset
   repeat while duration < maxdur
      n += n
      duration -= cnt
      repeat n
         block.writeblock(ptr++, @bigbuf)
      duration += cnt
   addspeed(string("Raw write"), duration, (ptr-offset)*512)
   ' try a non-sequential write
   pfw.str(string(13,"Do a single non-sequential write...",13))
  
   ptr += 10   
   block.writeblock(ptr, @bigbuf)
   pfw.str(string(13,"Done", 13))
   pfw.newline

   pfw.str(string(13,"How fast can we read, sequentially?", 13))

   n := 128
   duration := 0
   ptr := offset
   repeat while duration < maxdur
      n += n
      duration -= cnt
      repeat n
         block.readblock(ptr++, @bigbuf)
      duration += cnt
   addspeed(string("Raw read"), duration, (ptr-offset)*512)
'
'   That's it for the block layer.
'
   stop_block_layer
pub fsrwspeed | r, startcnt, bytes, n, duration, i
'
'   Now we move on to the filesystem layer.
'
   pfw.str(string(13,"Now the filesystem tests",13))
  
   pfw.str(string(13,"Trying to mount ",13))
   
   sdfat.mount(18)
   pfw.str(string(13,"Mounted.",13))
   
   ' determine the write speed first, then use that size for the read
   pfw.str(string(13,"How fast can we write using pwrite?",13))
   
   n := 0
   i := 2
   duration := 0
   sdfat.popen(string("speed.tst"),"w")
   repeat while duration < maxdur
      i += i
      n += i
      duration -= cnt
      repeat i
         sdfat.pwrite(@bigbuf, 8192)
      duration += cnt
   sdfat.pclose
   addspeed(string("fsrw pwrite"), duration, n*8192)
   ' now determine the read speed
 
   pfw.str(string(13,"How fast can we read using pread?",13))
  
  sdfat.popen(string("speed.tst"),"r")
   duration := -cnt
   repeat n
      sdfat.pread(@bigbuf, 8192)
   duration += cnt
   sdfat.pclose
   addspeed(string("fsrw pread"), duration, n*8192)
    
   pfw.str(string(13,"How fast can we write using pput ",13))
  
   n := 0
   i := 512
   duration := 0
   sdfat.popen(string("speed.tst"),"w")
   repeat while duration < maxdur
      i += i
      n += i      
      duration -= cnt
      repeat i
        sdfat.pputc("!")
      duration += cnt
   sdfat.pclose
   addspeed(string("FSRW pputc"), duration, n)
                        pfw.newline
   pfw.str(string(13,"How fast can we read using pgetc?",13))
  
   sdfat.popen(string("speed.tst"),"r")
   duration := -cnt
   repeat n
     sdfat.pgetc
   duration += cnt
   sdfat.pclose
   addspeed(string("FSRW pgetc"), duration, n)

' copy speed.tst to speed2.tst

   sdfat.popen(string("speed.tst"),"r")
  ' sdfat.popen(string("speed2.tst"),"w")
   repeat while (i:=sdfat.pgetc)=>0
     sdfat.pputc(i)
   'sdfat.pclose
   sdfat.pclose
      
pub initPins
  dirA[DEV_SPI_ADD0]   := 1             'makes address 0 and 1          
  dirA[DEV_SPI_ADD1]   := 1             'outputs
  dirA[DEV_SPI_EN]     := 1              'and enable an output as well
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := 3
  OUTA[DEV_SPI_EN]     := 1             'Disable - Reset Screen
  
PUB SD_speedtest  | r, sta, bytes, CHAR                 ''works?
  OUTA[DEV_SPI_EN] := 1    
  outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
  dira[DEV_SPI_EN..DEV_SD_CLK] := 0
  dira[DEV_SPI_ADD1..DEV_SPI_ADD0] := 1
  pfw.size(2)
  pfw.clearscreen(0)
  pfw.setColors($0000,$FFFF)  
  pfw.Str(string("Starting SD card"))        ' helpful message if card is out, better than just a blank screen
  pfw.newline                          
  Pfw.str(string("Mounting."))
  pfw.newline    
   sdfat.mount(18)
   Pfw.str(string("Mounted."))
   pfw.newline
   wait.Pause1s(1)
   Pfw.str(string("Dir:"))
   pfw.newline 
   sdfat.opendir
   repeat while 0 == sdfat.nextfile(@tbuf)
      Pfw.str(@tbuf)
      Pfw.newline     
   Pfw.str(string("That's the dir"))      
   sta := cnt
   r := sdfat.popen(string("speed.txt"), "w")
   repeat 256
      sdfat.pwrite(@bigbuf, 8192)
                  
   r := (cnt - sta) >> 2
   sdfat.pclose
   pfw.newline
   Pfw.str(string("Writing 2M took "))
   pfw.dec(r)
   Pfw.newline
   sta := cnt
   r := sdfat.popen(string("speed.txt"), "r")
   repeat 256
      sdfat.pread(@bigbuf, 8192)
   r := (cnt - sta) >> 2      
   sdfat.pclose
   sdfat.release
   sdfat.unmount
   Pfw.str(string("Reading 2M took "))
   pfw.dec(r)
   Pfw.newline
   Pfw.str(string("That's, all, folks! "))
   pfw.size(1)   
   wait.pause1s(1)
   tswait
    
PUB hardwareInit
   ButtonReg := $ffff
   SendSwitch(ButtonReg)
      
PUB LCD_Menu | data, tmpx, tmpy, f,b
      pfw.clearscreen(backgroundcolor)
      pfw.size(1)
      pfw.setChar(0, 8, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.str(string("Font"))
      pfw.setChar(32, 8, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.str(string("Test"))
                                                  
     ' pfw.setChar(0, 7*15, 0, 0, BackgroundColor, ActiveTextColor)
     ' pfw.str(string("Fader"))
     ' pfw.setChar(32, 7 * 16, 0, 0, BackgroundColor, ActiveTextColor)
     ' pfw.str(string("Test"))
      
      pfw.setChar(0, 14*14, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.str(string("SD Card"))
      pfw.setChar(32, 14 * 16, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.str(string("Test"))

     Data := TSWait 
     tmpx := data & $0000_FFFF
     tmpy := data >> 16
      if tmpx > 2800
        if  tmpy > 2800   
           FontTest  
      'elseif (1700 < tmpy) and (tmpy <    2700)
      '   startWindow
      '   repeat
      '     FaderT
        elseif  (600  < tmpy) and (tmpy   < 1600)
          \go'PFW.dec(\SD_speedtest)
          wait.pause1s(10) 
          tswait
          
          '
PUB FontTest
pfw.clearscreen(backgroundcolor)
SizeTest
 TSWait
 
PUB SizeTest | s , tmpx, tmpy
      pfw.size(1)
      pfw.setChar( 0, 0, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.str(string("Large Font"))
      pfw.setChar(128, 0, 0, 0, BackgroundColor, ActiveTextColor)
      pfw.size(2)
      pfw.str(string("Small Font"))
      s := tswait
     tmpx := s & $0000_FFFF
     tmpy := s >> 16
     if tmpx > 2500
       pfw.size(1)
     else
       pfw.size(2)
    pfw.clearscreen(0)       
    pfw.setChar( 0, 0, 0, 0, 0, $ffff)
       repeat s from 0 to 128
         pfw.char(s)
      tswait 
       repeat s from 129 to 255
         pfw.char(s)         
       repeat s from 0 to 11
         pfw.char(32)  
      tswait    
PUB TSWait  | yval, xval,x,y
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := TSC        ''Old format was      OUTA[TS_CS] := 0     ' enable the touch screen    '  
  dirA[DEV_SPI_EN] := 1 
  dirA[DEV_SPI_ADD1] :=1
  dirA[DEV_SPI_ADD0] := 1 
   outa[DEV_SPI_EN] := 1   
  wait.pause1ms(100)
   repeat
     OUTA[DEV_SPI_EN] := 0
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1101_0000)  ' reads x from  500 to 3700  (off < 500 )
      xval := SPI.SHIFTIN(DEV_SD_DO, DEV_SD_CLK,2, 12)
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1001_0000)  ' reads y from 400 to 3800 (off > 3800 ) 
      yval := SPI.SHIFTIN(DEV_SD_DO,DEV_SD_CLK,2, 12)
       if xval <>  0
         result := xval + (yval << 16)
         OUTA[DEV_SPI_EN] := 1
         outa[DEV_SPI_ADD1..DEV_SPI_ADD0] := SDC
         RETURN
       ELSE 
         wait.pause1ms(100)

PRI SendPot(Address, Data) | D
   Set_Spi_Ext_Address(DEV_SPI_EXT_POT_CS)
        address <<= 8
      d := data + address
      wait.pause1ms(10)
    outa[DEV_SPI_EN] := 0
    wait.pause1ms(10)
   SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 11, d)    
      wait.pause1ms(10)   
   outa[DEV_SPI_EN] := 1  

PRI  SendSwitch(data)
      Set_Spi_Ext_Address(DEV_SPI_EXT_SW_CS)
      SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 8, data)
       wait.pause1ms(10)
      StrobeCS
      'Set_Spi_Ext_Address(3)
      
PUB Set_Spi_Ext_Address(Ext_Spi_Address)
outa[DEV_SPI_EN] := 1
OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := EXT
  wait.pause1ms(10)  
  OUTA[DEV_SPI_ADD_LE] := 0
   wait.pause1ms(10)
  SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 3, Ext_Spi_Address)
  wait.pause1ms(10)
  OUTA[DEV_SPI_ADD_LE] := 1
  wait.pause1ms(10)
  OUTA[DEV_SPI_ADD_LE] := 0  
    wait.pause1ms(10)
    
PUB StrobeCS
   OUTA[DEV_SPI_EN] := 0
   wait.pause1ms(10)
   OUTA[DEV_SPI_EN] := 1

'pub deadend                                                               'loop for testing
' repeat                                                                             'endlessly wait
'   repeat
'    waitcnt(2_000 + cnt)